VERSION 2.00
Begin Form DEVICE 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Double
   Caption         =   "DEVICE"
   ClientHeight    =   4470
   ClientLeft      =   1050
   ClientTop       =   1845
   ClientWidth     =   6195
   FontBold        =   0   'False
   FontItalic      =   0   'False
   FontName        =   "Courier New"
   FontSize        =   8.25
   FontStrikethru  =   0   'False
   FontUnderline   =   0   'False
   Height          =   5160
   Left            =   990
   LinkTopic       =   "Form1"
   ScaleHeight     =   4470
   ScaleWidth      =   6195
   Top             =   1215
   Width           =   6315
   Begin TextBox editMessage 
      Height          =   2535
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   7
      Top             =   1680
      Width           =   5895
   End
   Begin CommandButton buttonDecrement 
      Caption         =   "Decrement"
      Height          =   375
      Left            =   3600
      TabIndex        =   5
      Top             =   600
      Width           =   1095
   End
   Begin CommandButton ButtonIncrement 
      Caption         =   "Increment"
      Height          =   375
      Left            =   2400
      TabIndex        =   4
      Top             =   600
      Width           =   1095
   End
   Begin TextBox editDelay 
      Height          =   375
      Left            =   1680
      TabIndex        =   3
      Text            =   "125"
      Top             =   600
      Width           =   615
   End
   Begin CommandButton buttonSend 
      Caption         =   "Send String"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1080
      Width           =   2175
   End
   Begin TextBox editString 
      Height          =   375
      Left            =   1680
      TabIndex        =   0
      Text            =   "AT"
      Top             =   120
      Width           =   4215
   End
   Begin Timer Timer1 
      Interval        =   125
      Left            =   5400
      Top             =   600
   End
   Begin Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Char Delay"
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   600
      Width           =   1455
   End
   Begin Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "String To Send"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1455
   End
   Begin Menu menuLine 
      Caption         =   "Line"
      Begin Menu menuExit 
         Caption         =   "E&xit"
      End
      Begin Menu menuOnLine 
         Caption         =   "OnLine"
      End
      Begin Menu menuOffLine 
         Caption         =   "OffLine"
         Enabled         =   0   'False
      End
   End
   Begin Menu menuChange 
      Caption         =   "Change"
      Begin Menu menuPort 
         Caption         =   "Port"
         Begin Menu menuCOM1 
            Caption         =   "COM1"
            Checked         =   -1  'True
         End
         Begin Menu menuCOM2 
            Caption         =   "COM2"
         End
         Begin Menu menuCOM3 
            Caption         =   "COM3"
         End
         Begin Menu menuCOM4 
            Caption         =   "COM4"
         End
      End
      Begin Menu menuBaud 
         Caption         =   "Baud"
         Begin Menu menu110 
            Caption         =   "110"
         End
         Begin Menu menu300 
            Caption         =   "300"
         End
         Begin Menu menu1200 
            Caption         =   "1200"
         End
         Begin Menu menu2400 
            Caption         =   "2400"
         End
         Begin Menu menu4800 
            Caption         =   "4800"
         End
         Begin Menu menu9600 
            Caption         =   "9600"
         End
         Begin Menu menu19200 
            Caption         =   "19200"
            Checked         =   -1  'True
         End
         Begin Menu menu38400 
            Caption         =   "38400"
         End
         Begin Menu menu57600 
            Caption         =   "57600"
         End
      End
   End
End

' DEVICE.BAS

Option Explicit

Sub buttonDecrement_Click ()
Dim Value As Long
Value = Val(editDelay.Text) - 25
If Value < 0 Then
  Value = 0
End If
editDelay.Text = Str$(Value)
Timer1.Interval = Value
End Sub

Sub ButtonIncrement_Click ()
Dim Value As Long
Value = Val(editDelay.Text) + 25
editDelay.Text = Str$(Value)
Timer1.Interval = Value
End Sub

Sub buttonSend_Click ()
' queue string plus carriage return
SendBuffer = editString.Text + Chr$(13)
SendFirst = 1
SendNext = Len(editString.Text) + 2
End Sub

Sub Form_KeyPress (KeyAscii As Integer)
    Dim Code As Integer
    If KeyAscii <> 10 Then
      Code = SioPutc(ThePort, KeyAscii)
    End If
End Sub

Sub Form_Load ()
Dim Code As Integer
    Dim Row As Integer
    BaudRateTable(0) = "110"
    BaudRateTable(1) = "300"
    BaudRateTable(2) = "1200"
    BaudRateTable(3) = "2400"
    BaudRateTable(4) = "4800"
    BaudRateTable(5) = "9600"
    BaudRateTable(6) = "19200"
    BaudRateTable(7) = "38400"
    BaudRateTable(8) = "57600"
    FatalFlag = 0
    ThePort = COM1
    TheBaudCode = Baud19200
    SendFirst = 0
    SendNext = 0
    buttonSend.Enabled = False
    OnLineFlag = 0
    Code = SioDTR(ThePort, Asc("S"))
    Code = SioRTS(ThePort, Asc("S"))
    Call ShowConfig
End Sub

Sub menu110_Click ()
  Call UncheckBaudRate
  menu110.Checked = True
  TheBaudCode = Baud110
  Call SetBaud
  Call ShowConfig
End Sub

Sub menu1200_Click ()
  Call UncheckBaudRate
  menu1200.Checked = True
  TheBaudCode = Baud1200
  Call SetBaud
  Call ShowConfig
End Sub

Sub menu19200_Click ()
  Call UncheckBaudRate
  menu19200.Checked = True
  TheBaudCode = Baud19200
  Call SetBaud
  Call ShowConfig
End Sub

Sub menu2400_Click ()
  Call UncheckBaudRate
  menu2400.Checked = True
  TheBaudCode = Baud2400
  Call SetBaud
  Call ShowConfig
End Sub

Sub menu300_Click ()
  Call UncheckBaudRate
  menu300.Checked = True
  TheBaudCode = Baud300
  Call SetBaud
  Call ShowConfig
End Sub

Sub menu38400_Click ()
  Call UncheckBaudRate
  menu38400.Checked = True
  TheBaudCode = Baud38400
  Call SetBaud
  Call ShowConfig
End Sub

Sub menu4800_Click ()
  Call UncheckBaudRate
  menu4800.Checked = True
  TheBaudCode = Baud4800
  Call SetBaud
  Call ShowConfig
End Sub

Sub menu57600_Click ()
  Call UncheckBaudRate
  menu57600.Checked = True
  TheBaudCode = Baud57600
  Call SetBaud
  Call ShowConfig
End Sub

Sub menu9600_Click ()
  Call UncheckBaudRate
  menu9600.Checked = True
  TheBaudCode = Baud9600
  Call SetBaud
  Call ShowConfig
End Sub

Sub menuCOM1_Click ()
  Call UncheckComPorts
  menuCOM1.Checked = True
  ThePort = COM1
  Call ShowConfig
End Sub

Sub menuCOM2_Click ()
  Call UncheckComPorts
  menuCOM2.Checked = True
  ThePort = COM2
  Call ShowConfig
End Sub

Sub menuCOM3_Click ()
  Call UncheckComPorts
  menuCOM3.Checked = True
  ThePort = COM3
  Call ShowConfig
End Sub

Sub menuCOM4_Click ()
  Call UncheckComPorts
  menuCOM4.Checked = True
  ThePort = COM4
  Call ShowConfig
End Sub

Sub menuExit_Click ()
  Call GoOffLine
  End
End Sub

Sub menuOffLine_Click ()
  menuChange.Enabled = True
  menuOffline.Enabled = False
  menuOnline.Enabled = True
  Call GoOffLine
  Call ShowConfig
End Sub

Sub menuOnLine_Click ()
  menuOffline.Enabled = True
  menuOnline.Enabled = False
  menuChange.Enabled = False
  editMessage.Text = ""
  Call GoOnLine
  Call ShowConfig
End Sub

Sub Timer1_Timer ()
  Dim Code As Integer
  Dim C As Integer
  If OnLineFlag Then
    Timer1.Enabled = False
    ' get incoming serial data
    Call GetIncoming
    ' anything to send ?
    If SendFirst = SendNext Then
      ' buffer is empty
      SendFirst = 0
      SendNext = 0
    Else
      ' send next character
      C = Asc(Mid$(SendBuffer, SendFirst, 1))
      SendFirst = SendFirst + 1
      Code = SioPutc(ThePort, C)
    End If
    ' re-enable timer
    Timer1.Enabled = True
  End If
End Sub

Sub UncheckBaudRate ()
'uncheck all baud rates
menu110.Checked = False
menu300.Checked = False
menu1200.Checked = False
menu2400.Checked = False
menu4800.Checked = False
menu9600.Checked = False
menu19200.Checked = False
menu38400.Checked = False
menu57600.Checked = False
End Sub

Sub UncheckComPorts ()
'uncheck all COM ports
menuCOM1.Checked = False
menuCOM2.Checked = False
menuCOM3.Checked = False
menuCOM4.Checked = False
End Sub

